﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using C1.Win.C1Chart;

namespace C1Chart_CustomTrendline
{
    
    public partial class ChartTrendline : Form
    {
        public ChartTrendline()
        {
            InitializeComponent();
        }
      
        private void Form1_Load(object sender, EventArgs e)
        {
            c1Chart1.BackColor = Color.LemonChiffon;
        }
     
        //Create static variables used to plot Custom 
        //Trendlines to track the current on the TrackBars
        static bool bar1 = false;
        static int a = 0,b = 0;
        public static int y1()
        {
            if (bar1 == true)
                return b;
            else
            return a;
        }

        public static int y2()
        {
            if (bar1 == true)
                return a;
            else
            return b;
        }

        private void DrawLevelLine()
        {
            c1Chart1.ChartGroups[0].ChartData.TrendsList.Clear();
            // create trend line
            C1.Win.C1Chart.TrendLine tl = c1Chart1.ChartGroups[0].ChartData.TrendsList.AddNewTrendLine();
            // setup line properties
            tl.LineStyle.Color = Color.DarkRed;
            tl.LineStyle.Thickness = 3;
            tl.LineStyle.Pattern = C1.Win.C1Chart.LinePatternEnum.Dash;
            // set custom trend line
            tl.CustomTrendLine = new CustomTrendLine();
            if(bar1 == true)
            bar1 = false;
        }

        bool draw = false;
        //Capture the Trackbar Values
        private void trackBar1_ValueChanged(object sender, EventArgs e)
        {
            bar1 = true;
            draw = true;
            a = trackBar1.Value;
            b = trackBar2.Value;
        }

        private void trackBar1_MouseUp(object sender, MouseEventArgs e)
        {
            if (draw)
            {
                DrawLevelLine();
                draw = false;
            }
        }

        private void trackBar2_ValueChanged(object sender, EventArgs e)
        {
            bar1 = false;
            draw = true;
            a = trackBar1.Value;
            b = trackBar2.Value;
        }

        private void trackBar2_MouseUp(object sender, MouseEventArgs e)
        {
            if (draw)
            {
                DrawLevelLine();
                draw = false;
            }
        }

    }

    public class CustomTrendLine : C1.Win.C1Chart.ICustomTrendLine
    {
        private double[] _x;

        private double[] _y;
   
        public void Calculate(C1.Win.C1Chart.TrendLine tl, double[] x, double[] y)
        {

            if (x == null || x.Length == 0 || y == null || y.Length == 0)
            {
                _x = null; _y = null;
                return;
            }

            // find min and max
            double xmin = x[0], xmax = x[0];
            double ymin1 = y[0], ymax1 = y[0];

            ChartTrendline ff = new ChartTrendline();
            xmin = ff.c1Chart1.ChartArea.AxisX.Min;
            xmax = ff.c1Chart1.ChartArea.AxisX.Max;

            ymin1 = ChartTrendline.y1();
            ymax1 = ChartTrendline.y2();

            _x = new double[2];
            _y = new double[2];

            _x[0] = xmin; _y[0] = ymin1;
            _x[1] = xmax; _y[1] = ymax1;
            }



        public double[] GetXValues() { return _x; }

        public double[] GetYValues() { return _y; }



        // don't use it just return something

        public double GetY(double x) { return 0; }

        public string Text { get { return "Custom trend"; } }

    }
}
